(* file: part1.ml
   author: Bob Muller
   date: January 20, 2015
   revised: September 10, 2015

   Harness code for part1 of problem set 2.
 *)

(* oneOrTheOtherNotBoth : bool -> bool -> bool

 The call (oneOrTheOtherNotBoth b1 b2) should return true if one of
 b1 or b2 is true. It should return false if neither or both are true.
*)
let oneOrTheOtherNotBoth b1 b2 =
  match b1 with
  | true  -> not b2
  | false -> b2

let test () : bool =
  (oneOrTheOtherNotBoth true false) &&
    (oneOrTheOtherNotBoth false true) &&
      (not (oneOrTheOtherNotBoth false false)) &&
	(not (oneOrTheOtherNotBoth true true));;

Assert.run_test "oneOrTheOtherNotBoth test" test

(* randBetween : int -> int -> int

 The call (randBetween low hi) should return a random integer between
 low and hi.  The value can be low but should be strictly lower than hi.
 *)
let randBetween low high =
  let n = Random.int (high - low)
  in
  low + n

let test () : bool =
  let r1 = randBetween 1 2 in
  let r2 = randBetween 4 10
  in
  r1 = 1 && r2 >= 4 && r2 < 10;;

Assert.run_test "randBetween test" test

(* longer : string -> string -> string

 The call (longer s1 s2) should return a string indicating which
 of s1 or s2 was longer. If s1 is longer, longer should return
 "first". If s2 is longer, longer should return "second". If they
 are of the same length, longer should return "they are equal".
 *)
let longer s1 s2 =
  let l1 = String.length s1 in
  let l2 = String.length s2 in
  match l1 > l2 with
  | true  -> "first"
  | false -> (match l1 = l2 with
              | true  -> "they are equal"
              | false -> "second")

let test () : bool =
  let ans1 = longer "AB" "" in
  let ans2 = longer "AB" "AB" in
  let ans3 = longer "" "AB"
  in
  ans1 = "first" && ans2 = "they are equal" && ans3 = "second";;

Assert.run_test "longer test" test
